/* Demonstration of pass by reference.  This requires pointers.  We
 * can force pass by reference.  The two important operators pertinent
 * to working with pointers are:
 *
 *     & = "address of" operator
 *     * = dereference operator (value at the memory location...)
 */

#include <stdio.h>

void change_ij(int*, int*);  // function prototype

int main() {
  int i=10, j=42;

  printf("in main. i = %d, j = %d\n", i, j);

  change_ij(&i, &j);

  printf("in main. i = %d, j = %d\n", i, j);

  return 0;
}

void change_ij(int* a, int* b) {
  // a, b are pointers (memory location where
  //    an integer is stored).
  *a = *a + 2;
  *b += 10;
  printf("change_i: %d %d\n", *a, *b);
  printf("change_i: %p %p\n", a, b);

}